// **********************************************************************
//
// Copyright (c) 2001 MT Tools.
//
// All Rights Reserved
//
// MT_DORB is based in part on the product DORB,
// written by Shadrin Victor
//
// See Readme.txt for contact information
//
// **********************************************************************
unit cosnaming;

interface

uses
  Classes,orb_int,orb,req_int,code_int,imr,imr_int,env_int,stdstat,std_seq,
  orbtypes,exceptions,except_int,cosnaming_int, poa_int, poa;

type

{$IFNDEF USELIB}

  TNameComponent_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

  TNameComponent_seq_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

  TBindingType_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

  TBinding_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

  TBinding_seq_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

  TNamingContext_NotFoundReason_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

  TNamingContext_NotFound_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

{$ENDIF}

  {** IDL:omg.org/CosNaming/NamingContext/NotFound:1.0 }
  TNamingContext_NotFound = class(UserException,INamingContext_NotFound)
  private
    Fwhy : TNamingContext_NotFoundReason;
    Frest_of_name : TName;
  protected
    procedure throw; override;
    function clone(): IORBException; override;
    function repoid(): PChar; override;
    procedure encode(const enc: IEncoder); override;
    procedure why(const val : TNamingContext_NotFoundReason); overload;
    procedure rest_of_name(const val : TName); overload;
  public
    function why: TNamingContext_NotFoundReason; overload;
    function rest_of_name: TName; overload;
    constructor Create(ex: TNamingContext_NotFound); overload;
    constructor Create(_why: TNamingContext_NotFoundReason = missing_node;_rest_of_name: TName = nil); overload;
  end;

{$IFNDEF USELIB}

  TNamingContext_CannotProceed_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

{$ENDIF}

  {** IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0 }
  TNamingContext_CannotProceed = class(UserException,INamingContext_CannotProceed)
  private
    Fcxt : INamingContext;
    Frest_of_name : TName;
  protected
    procedure throw; override;
    function clone(): IORBException; override;
    function repoid(): PChar; override;
    procedure encode(const enc: IEncoder); override;
    procedure cxt(const val : INamingContext); overload;
    procedure rest_of_name(const val : TName); overload;
  public
    function cxt: INamingContext; overload;
    function rest_of_name: TName; overload;
    constructor Create(ex: TNamingContext_CannotProceed); overload;
    constructor Create(_cxt: INamingContext = nil;_rest_of_name: TName = nil); overload;
  end;

{$IFNDEF USELIB}

  TNamingContext_InvalidName_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

{$ENDIF}

  {** IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0 }
  TNamingContext_InvalidName = class(UserException,INamingContext_InvalidName)
  protected
    procedure throw; override;
    function clone(): IORBException; override;
    function repoid(): PChar; override;
    procedure encode(const enc: IEncoder); override;
  public
    constructor Create(ex: TNamingContext_InvalidName); overload;
    constructor Create(); overload;
  end;

{$IFNDEF USELIB}

  TNamingContext_AlreadyBound_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

{$ENDIF}

  {** IDL:omg.org/CosNaming/NamingContext/AlreadyBound:1.0 }
  TNamingContext_AlreadyBound = class(UserException,INamingContext_AlreadyBound)
  protected
    procedure throw; override;
    function clone(): IORBException; override;
    function repoid(): PChar; override;
    procedure encode(const enc: IEncoder); override;
  public
    constructor Create(ex: TNamingContext_AlreadyBound); overload;
    constructor Create(); overload;
  end;

{$IFNDEF USELIB}

  TNamingContext_NotEmpty_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

{$ENDIF}

  {** IDL:omg.org/CosNaming/NamingContext/NotEmpty:1.0 }
  TNamingContext_NotEmpty = class(UserException,INamingContext_NotEmpty)
  protected
    procedure throw; override;
    function clone(): IORBException; override;
    function repoid(): PChar; override;
    procedure encode(const enc: IEncoder); override;
  public
    constructor Create(ex: TNamingContext_NotEmpty); overload;
    constructor Create(); overload;
  end;

{$IFNDEF USELIB}  

  {** IDL:omg.org/CosNaming/NamingContext:1.0 } 
  TNamingContext = class(TORBObject,INamingContext)
  protected
    procedure bind(const n: TName; const obj: IORBObject); virtual;
    procedure rebind(const n: TName; const obj: IORBObject); virtual;
    procedure bind_context(const n: TName; const nc: INamingContext); virtual;
    procedure rebind_context(const n: TName; const nc: INamingContext); virtual;
    function resolve(const n: TName): IORBObject; virtual;
    procedure unbind(const n: TName); virtual;
    function new_context: INamingContext; virtual;
    function bind_new_context(const n: TName): INamingContext; virtual;
    procedure _destroy; virtual;
    procedure list(const how_many: _ulong; out bl: TBindingList; out bi: IBindingIterator); virtual;
    function narrow_helper(const str: string): Pointer; override;
  public
    class function _narrow(const obj : IORBObject): INamingContext;
    class function narrow_helper2(const obj: IORBObject): Boolean;
  end;

  {** stub for interface IDL:omg.org/CosNaming/NamingContext:1.0}
  TNamingContext_stub = class(TNamingContext)
  protected
    procedure bind(const n: TName; const obj: IORBObject); override;
    procedure rebind(const n: TName; const obj: IORBObject); override;
    procedure bind_context(const n: TName; const nc: INamingContext); override;
    procedure rebind_context(const n: TName; const nc: INamingContext); override;
    function resolve(const n: TName): IORBObject; override;
    procedure unbind(const n: TName); override;
    function new_context: INamingContext; override;
    function bind_new_context(const n: TName): INamingContext; override;
    procedure _destroy; override;
    procedure list(const how_many: _ulong; out bl: TBindingList; out bi: IBindingIterator); override;
  end;

  {** POA stub for interface IDL:omg.org/CosNaming/NamingContext:1.0}
  TNamingContext_stub_clp = class(TPOAStub,IPOAStub,INamingContext)
  protected
    procedure bind(const n: TName; const obj: IORBObject); virtual;
    procedure rebind(const n: TName; const obj: IORBObject); virtual;
    procedure bind_context(const n: TName; const nc: INamingContext); virtual;
    procedure rebind_context(const n: TName; const nc: INamingContext); virtual;
    function resolve(const n: TName): IORBObject; virtual;
    procedure unbind(const n: TName); virtual;
    function new_context: INamingContext; virtual;
    function bind_new_context(const n: TName): INamingContext; virtual;
    procedure _destroy; virtual;
    procedure list(const how_many: _ulong; out bl: TBindingList; out bi: IBindingIterator); virtual;
    function narrow_helper(const str: string): Pointer; override;
  end;

{$ENDIF}

  {** servant for interface IDL:omg.org/CosNaming/NamingContext:1.0}
  TNamingContext_serv = class(TPOAStaticImplementation,IPOAStaticImplementation,IServant,INamingContext)
  protected
    procedure bind(const n: TName; const obj: IORBObject); virtual;abstract;
    procedure rebind(const n: TName; const obj: IORBObject); virtual;abstract;
    procedure bind_context(const n: TName; const nc: INamingContext); virtual;abstract;
    procedure rebind_context(const n: TName; const nc: INamingContext); virtual;abstract;
    function resolve(const n: TName): IORBObject; virtual;abstract;
    procedure unbind(const n: TName); virtual;abstract;
    function new_context: INamingContext; virtual;abstract;
    function bind_new_context(const n: TName): INamingContext; virtual;abstract;
    procedure _destroy; virtual;abstract;
    procedure list(const how_many: _ulong; out bl: TBindingList; out bi: IBindingIterator); virtual;abstract;
    function _primary_interface(const objid: ObjectID; const poa: IPOA): string; override;
    function _make_stub(const poa: IPOA; const obj : IORBObject): IORBObject; override;
    function _is_a(const repoid: RepositoryID): Boolean; override;
    procedure invoke(const serv: IStaticServerRequest); override;
    function _dispatch(const req: IStaticServerRequest): Boolean;
    function narrow_helper(const str: string): Pointer; override;
  public
    function _this(): INamingContext;
    class function _narrow(const srv : IServant): INamingContext;
  end;

{$IFNDEF USELIB}  

  TNamingContext_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

{$ENDIF}

  {** IDL:omg.org/CosNaming/BindingIterator:1.0 }
  TBindingIterator = class(TORBObject,IBindingIterator)
  protected
    function next_one(out b: TBinding): boolean; virtual;
    function next_n(const how_many: _ulong; out bl: TBindingList): boolean; virtual;
    procedure _destroy; virtual;
    function narrow_helper(const str: string): Pointer; override;
  public
    class function _narrow(const obj : IORBObject): IBindingIterator;
    class function narrow_helper2(const obj: IORBObject): Boolean;
  end;

  {** stub for interface IDL:omg.org/CosNaming/BindingIterator:1.0}
  TBindingIterator_stub = class(TBindingIterator)
  protected
    function next_one(out b: TBinding): boolean; override;
    function next_n(const how_many: _ulong; out bl: TBindingList): boolean; override;
    procedure _destroy; override;
  end;

  {** POA stub for interface IDL:omg.org/CosNaming/BindingIterator:1.0}
  TBindingIterator_stub_clp = class(TPOAStub,IPOAStub,IBindingIterator)
  protected
    function next_one(out b: TBinding): boolean; virtual;
    function next_n(const how_many: _ulong; out bl: TBindingList): boolean; virtual;
    procedure _destroy; virtual;
    function narrow_helper(const str: string): Pointer; override;
  end;

  {** servant for interface IDL:omg.org/CosNaming/BindingIterator:1.0}
  TBindingIterator_serv = class(TPOAStaticImplementation,IPOAStaticImplementation,IServant,IBindingIterator)
  protected
    function next_one(out b: TBinding): boolean; virtual;abstract;
    function next_n(const how_many: _ulong; out bl: TBindingList): boolean; virtual;abstract;
    procedure _destroy; virtual;abstract;
    function _primary_interface(const objid: ObjectID; const poa: IPOA): string; override;
    function _make_stub(const poa: IPOA; const obj : IORBObject): IORBObject; override;
    function _is_a(const repoid: RepositoryID): Boolean; override;
    procedure invoke(const serv: IStaticServerRequest); override;
    function _dispatch(const req: IStaticServerRequest): Boolean;
    function narrow_helper(const str: string): Pointer; override;
  public
    function _this(): IBindingIterator;
    class function _narrow(const srv : IServant): IBindingIterator;
  end;

{$IFNDEF USELIB}

  TBindingIterator_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

  TNamingContextExt_InvalidAddress_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;

{$ENDIF}

  {** IDL:omg.org/CosNaming/NamingContext/InvalidAddress:1.0 }
  TNamingContextExt_InvalidAddress = class(UserException,INamingContextExt_InvalidAddress)
  protected
    procedure throw; override;
    function clone(): IORBException; override;
    function repoid(): PChar; override;
    procedure encode(const enc: IEncoder); override;
  public
    constructor Create(ex: TNamingContextExt_InvalidAddress); overload;
    constructor Create(); overload;
  end;

{$IFNDEF USELIB}

  {** IDL:omg.org/CosNaming/NamingContextExt:1.0 } 
  TNamingContextExt = class(TNamingContext,INamingContextExt)
  protected
    function to_string(const n: TName): TNamingContextExt_StringName; virtual;
    function to_name(const sn: TNamingContextExt_StringName): TName; virtual;
    function to_url(const addr: TNamingContextExt_Address; const sn: TNamingContextExt_StringName): TNamingContextExt_URLString; virtual;
    function resolve_str(const n: TNamingContextExt_StringName): IORBObject; virtual;
    function narrow_helper(const str: string): Pointer; override;
  public
    class function _narrow(const obj : IORBObject): INamingContextExt;
    class function narrow_helper2(const obj: IORBObject): Boolean;
  end;

  {** stub for interface IDL:omg.org/CosNaming/NamingContextExt:1.0}
  TNamingContextExt_stub = class(TNamingContextExt,INamingContextExt)
  protected
    procedure bind(const n: TName; const obj: IORBObject); override;
    procedure rebind(const n: TName; const obj: IORBObject); override;
    procedure bind_context(const n: TName; const nc: INamingContext); override;
    procedure rebind_context(const n: TName; const nc: INamingContext); override;
    function resolve(const n: TName): IORBObject; override;
    procedure unbind(const n: TName); override;
    function new_context: INamingContext; override;
    function bind_new_context(const n: TName): INamingContext; override;
    procedure _destroy; override;
    procedure list(const how_many: _ulong; out bl: TBindingList; out bi: IBindingIterator); override;
    function to_string(const n: TName): TNamingContextExt_StringName; override;
    function to_name(const sn: TNamingContextExt_StringName): TName; override;
    function to_url(const addr: TNamingContextExt_Address; const sn: TNamingContextExt_StringName): TNamingContextExt_URLString; override;
    function resolve_str(const n: TNamingContextExt_StringName): IORBObject; override;
  end;

  {** POA stub for interface IDL:omg.org/CosNaming/NamingContextExt:1.0} 
  TNamingContextExt_stub_clp = class(TNamingContext_stub_clp,INamingContextExt)
  protected
    function to_string(const n: TName): TNamingContextExt_StringName; virtual;
    function to_name(const sn: TNamingContextExt_StringName): TName; virtual;
    function to_url(const addr: TNamingContextExt_Address; const sn: TNamingContextExt_StringName): TNamingContextExt_URLString; virtual;
    function resolve_str(const n: TNamingContextExt_StringName): IORBObject; virtual;
    function narrow_helper(const str: string): Pointer; override;
  end;

{$ENDIF}

  {** servant for interface IDL:omg.org/CosNaming/NamingContextExt:1.0}
  TNamingContextExt_serv = class(TNamingContext_serv,INamingContextExt)
  protected
    function to_string(const n: TName): TNamingContextExt_StringName; virtual;abstract;
    function to_name(const sn: TNamingContextExt_StringName): TName; virtual;abstract;
    function to_url(const addr: TNamingContextExt_Address; const sn: TNamingContextExt_StringName): TNamingContextExt_URLString; virtual;abstract;
    function resolve_str(const n: TNamingContextExt_StringName): IORBObject; virtual;abstract;
    function _primary_interface(const objid: ObjectID; const poa: IPOA): string; override;
    function _make_stub(const poa: IPOA; const obj : IORBObject): IORBObject; override;
    function _is_a(const repoid: RepositoryID): Boolean; override;
    procedure invoke(const serv: IStaticServerRequest); override;
    function _dispatch(const req: IStaticServerRequest): Boolean;
    function narrow_helper(const str: string): Pointer; override;
  public
    function _this(): INamingContextExt;
    class function _narrow(const srv : IServant): INamingContextExt;
  end;

{$IFNDEF USELIB}

  TNamingContextExt_marshaller = class(TAbstractStat,IStaticTypeInfo)
  protected
    procedure _assign(dst,src: Pointer); override;
    function demarshal(dec: IDecoder;const addr : Pointer): Boolean;
    procedure marshal(enc: IEncoder; const addr : Pointer);
    procedure _create(var addr: Pointer); override;
    procedure _free(var addr: Pointer);
  end;


{$ENDIF}

{$IFNDEF USELIB}

  function NamingContextExt_narrow(const obj: IORBObject): INamingContextExt;
  function NamingContext_narrow(const obj: IORBObject): INamingContext;
  function NamingContextExt_stub_clp(const poa: IPOA; const obj : IORBObject): IORBObject;
  function NamingContext_stub_clp(const poa: IPOA; const obj : IORBObject): IORBObject;

{$IFDEF LIBRARY}
var
  _NameComponent_marshaller : IStaticTypeInfo;
  _NameComponent_seq_marshaller : IStaticTypeInfo;
  _BindingType_marshaller : IStaticTypeInfo;
  _Binding_marshaller : IStaticTypeInfo;
  _Binding_seq_marshaller : IStaticTypeInfo;
  _NamingContext_NotFoundReason_marshaller : IStaticTypeInfo;
  _NamingContext_NotFound_marshaller : IStaticTypeInfo;
  _NamingContext_CannotProceed_marshaller : IStaticTypeInfo;
  _NamingContext_InvalidName_marshaller : IStaticTypeInfo;
  _NamingContext_AlreadyBound_marshaller : IStaticTypeInfo;
  _NamingContext_NotEmpty_marshaller : IStaticTypeInfo;
  _NamingContext_marshaller : IStaticTypeInfo;
  _BindingIterator_marshaller : IStaticTypeInfo;
  _NamingContextExt_InvalidAddress_marshaller : IStaticTypeInfo;
  _NamingContextExt_marshaller : IStaticTypeInfo;

  function NameComponent_marshaller : IStaticTypeInfo;
  function NameComponent_seq_marshaller : IStaticTypeInfo;
  function BindingType_marshaller : IStaticTypeInfo;
  function Binding_marshaller : IStaticTypeInfo;
  function Binding_seq_marshaller : IStaticTypeInfo;
  function NamingContext_NotFoundReason_marshaller : IStaticTypeInfo;
  function NamingContext_NotFound_marshaller : IStaticTypeInfo;
  function NamingContext_CannotProceed_marshaller : IStaticTypeInfo;
  function NamingContext_InvalidName_marshaller : IStaticTypeInfo;
  function NamingContext_AlreadyBound_marshaller : IStaticTypeInfo;
  function NamingContext_NotEmpty_marshaller : IStaticTypeInfo;
  function NamingContext_marshaller : IStaticTypeInfo;
  function BindingIterator_marshaller : IStaticTypeInfo;
  function NamingContextExt_InvalidAddress_marshaller : IStaticTypeInfo;
  function NamingContextExt_marshaller : IStaticTypeInfo;


{$ELSE}
var
  NameComponent_marshaller : IStaticTypeInfo;
  NameComponent_seq_marshaller : IStaticTypeInfo;
  BindingType_marshaller : IStaticTypeInfo;
  Binding_marshaller : IStaticTypeInfo;
  Binding_seq_marshaller : IStaticTypeInfo;
  NamingContext_NotFoundReason_marshaller : IStaticTypeInfo;
  NamingContext_NotFound_marshaller : IStaticTypeInfo;
  NamingContext_CannotProceed_marshaller : IStaticTypeInfo;
  NamingContext_InvalidName_marshaller : IStaticTypeInfo;
  NamingContext_AlreadyBound_marshaller : IStaticTypeInfo;
  NamingContext_NotEmpty_marshaller : IStaticTypeInfo;
  NamingContext_marshaller : IStaticTypeInfo;
  BindingIterator_marshaller : IStaticTypeInfo;
  NamingContextExt_InvalidAddress_marshaller : IStaticTypeInfo;
  NamingContextExt_marshaller : IStaticTypeInfo;

{$ENDIF}
{$ELSE}
  function NameComponent_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function NameComponent_seq_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function BindingType_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function Binding_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function Binding_seq_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function NamingContext_NotFoundReason_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function NamingContext_NotFound_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function NamingContext_CannotProceed_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function NamingContext_InvalidName_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function NamingContext_AlreadyBound_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function NamingContext_NotEmpty_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function NamingContext_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function BindingIterator_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function NamingContext_narrow(const obj: IORBObject): INamingContext; external MTDORB_Library_Name;
  function NamingContext_stub_clp(const poa: IPOA; const obj : IORBObject): IORBObject; external MTDORB_Library_Name;
  function NamingContextExt_stub_clp(const poa: IPOA; const obj : IORBObject): IORBObject; external MTDORB_Library_Name;
  function NamingContextExt_InvalidAddress_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function NamingContextExt_marshaller : IStaticTypeInfo; external MTDORB_Library_Name;
  function NamingContextExt_narrow(const obj: IORBObject): INamingContextExt; external MTDORB_Library_Name;
{$ENDIF}

implementation

uses
  any,tcode,static,SysUtils,throw;

{$IFNDEF USELIB}

function NamingContextExt_narrow(const obj: IORBObject): INamingContextExt;
begin
  result := TNamingContextExt._narrow(obj);
end;

function NamingContext_narrow(const obj: IORBObject): INamingContext;
begin
  result := TNamingContext._narrow(obj);
end;

function NamingContextExt_stub_clp(const poa: IPOA; const obj : IORBObject): IORBObject;
begin
  result := TNamingContextExt_stub_clp.Create(poa,obj);
end;

function NamingContext_stub_clp(const poa: IPOA; const obj : IORBObject): IORBObject;
begin
  result := TNamingContext_stub_clp.Create(poa,obj);
end;

//***********************************************************
// TNameComponent_marshaller
//***********************************************************
function TNameComponent_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  struct: TNameComponent;
begin
  result := false;
  if not stat_string.demarshal(dec,@struct.id) then exit;
  if not stat_string.demarshal(dec,@struct.kind) then exit;
  TNameComponent(addr^) := struct;
  result := true;
end;

procedure TNameComponent_marshaller.marshal(enc: IEncoder;const addr : Pointer);
var
  struct: TNameComponent;
begin
  struct := TNameComponent(addr^);
  stat_string.marshal(enc,@struct.id);
  stat_string.marshal(enc,@struct.kind);
end;

procedure TNameComponent_marshaller._free(var addr: Pointer);
begin
  freemem(addr);
end;

procedure TNameComponent_marshaller._create(var addr: Pointer);
begin
  addr := allocmem(sizeOf(TNameComponent));
end;

procedure TNameComponent_marshaller._assign(dst, src: Pointer);
begin
  TNameComponent(dst^) := TNameComponent(src^);
end;

//***********************************************************
// TNameComponent_seq_marshaller
//***********************************************************
type 
  NameComponent_seq = array of TNameComponent;
  PNameComponent_seq = ^NameComponent_seq;

function TNameComponent_seq_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  len: _ulong;
  i: integer;
  val: TNameComponent;
begin
  result := false;
  if not dec.seq_begin(len) then exit;
  setLength(NameComponent_seq(addr^),len);
  for i := 0 to Pred(len) do
    begin
      if not NameComponent_marshaller.demarshal(dec,@val) then exit;
      NameComponent_seq(addr^)[i] := val; 
    end;
  if not dec.seq_end() then exit;
  result := true;
end;

procedure TNameComponent_seq_marshaller.marshal(enc: IEncoder;const addr : Pointer);
var
  len: _ulong;
  i: integer;
begin
  len := length(NameComponent_seq(addr^));
  enc.seq_begin(len);
  for i := 0 to Pred(len) do
    NameComponent_marshaller.marshal(enc,@NameComponent_seq(addr^)[i]);
  enc.seq_end;
end;

procedure TNameComponent_seq_marshaller._free(var addr: Pointer);
begin
  setLength(NameComponent_seq(addr^),0);
  freemem(addr);
end;

procedure TNameComponent_seq_marshaller._create(var addr: Pointer);
begin
  addr := allocmem(sizeOf(_ulong));
end;

procedure TNameComponent_seq_marshaller._assign(dst, src: Pointer);
begin
  _ulong(dst^) := _ulong(src^);
end;

//***********************************************************
// TBindingType_marshaller
//***********************************************************
function TBindingType_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
begin
  result := dec.get_ulong(_ulong(addr^));
end;

procedure TBindingType_marshaller.marshal(enc: IEncoder;const addr : Pointer);
begin
  enc.put_ulong(_ulong(addr^));
end;

procedure TBindingType_marshaller._free(var addr: Pointer);
begin
  freemem(addr);
end;

procedure TBindingType_marshaller._create(var addr: Pointer);
begin
  addr := allocmem(sizeOf(_ulong));
end;

procedure TBindingType_marshaller._assign(dst, src: Pointer);
begin
  TBindingType(dst^) := TBindingType(src^);
end;

//***********************************************************
// TBinding_marshaller
//***********************************************************
function TBinding_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  struct: TBinding;
begin
  result := false;
  if not NameComponent_seq_marshaller.demarshal(dec,@struct.binding_name) then exit;
  if not BindingType_marshaller.demarshal(dec,@struct.binding_type) then exit;
  TBinding(addr^) := struct;
  result := true;
end;

procedure TBinding_marshaller.marshal(enc: IEncoder;const addr : Pointer);
var
  struct: TBinding;
begin
  struct := TBinding(addr^);
  NameComponent_seq_marshaller.marshal(enc,@struct.binding_name);
  BindingType_marshaller.marshal(enc,@struct.binding_type);
end;

procedure TBinding_marshaller._free(var addr: Pointer);
begin
  freemem(addr);
end;

procedure TBinding_marshaller._create(var addr: Pointer);
begin
  addr := allocmem(sizeOf(TBinding));
end;

procedure TBinding_marshaller._assign(dst, src: Pointer);
begin
  TBinding(dst^) := TBinding(src^);
end;

//***********************************************************
// TBinding_seq_marshaller
//***********************************************************
type 
  Binding_seq = array of TBinding;
  PBinding_seq = ^Binding_seq;

function TBinding_seq_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  len: _ulong;
  i: integer;
  val: TBinding;
begin
  result := false;
  if not dec.seq_begin(len) then exit;
  setLength(Binding_seq(addr^),len);
  for i := 0 to Pred(len) do
    begin
      if not Binding_marshaller.demarshal(dec,@val) then exit;
      Binding_seq(addr^)[i] := val; 
    end;
  if not dec.seq_end() then exit;
  result := true;
end;

procedure TBinding_seq_marshaller.marshal(enc: IEncoder;const addr : Pointer);
var
  len: _ulong;
  i: integer;
begin
  len := length(Binding_seq(addr^));
  enc.seq_begin(len);
  for i := 0 to Pred(len) do
    Binding_marshaller.marshal(enc,@Binding_seq(addr^)[i]);
  enc.seq_end;
end;

procedure TBinding_seq_marshaller._free(var addr: Pointer);
begin
  setLength(Binding_seq(addr^),0);
  freemem(addr);
end;

procedure TBinding_seq_marshaller._create(var addr: Pointer);
begin
  addr := allocmem(sizeOf(_ulong));
end;

procedure TBinding_seq_marshaller._assign(dst, src: Pointer);
begin
  _ulong(dst^) := _ulong(src^);
end;

//***********************************************************
// TNamingContext_NotFoundReason_marshaller
//***********************************************************
function TNamingContext_NotFoundReason_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
begin
  result := dec.get_ulong(_ulong(addr^));
end;

procedure TNamingContext_NotFoundReason_marshaller.marshal(enc: IEncoder;const addr : Pointer);
begin
  enc.put_ulong(_ulong(addr^));
end;

procedure TNamingContext_NotFoundReason_marshaller._free(var addr: Pointer);
begin
  freemem(addr);
end;

procedure TNamingContext_NotFoundReason_marshaller._create(var addr: Pointer);
begin
  addr := allocmem(sizeOf(_ulong));
end;

procedure TNamingContext_NotFoundReason_marshaller._assign(dst, src: Pointer);
begin
  TNamingContext_NotFoundReason(dst^) := TNamingContext_NotFoundReason(src^);
end;

//***********************************************************
// TNamingContext_NotFound_marshaller
//***********************************************************
function TNamingContext_NotFound_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  repoid: string;
  _why: TNamingContext_NotFoundReason;
  _rest_of_name: TName;
begin
  result := false;
  if not dec.except_begin(repoid) then exit;
  if not NamingContext_NotFoundReason_marshaller.demarshal(dec,@_why) then exit;
  INamingContext_NotFound(addr^).why(_why);
  if not NameComponent_seq_marshaller.demarshal(dec,@_rest_of_name) then exit;
  INamingContext_NotFound(addr^).rest_of_name(_rest_of_name);
  if not dec.except_end then exit;
  result := true;
end;

procedure TNamingContext_NotFound_marshaller.marshal(enc: IEncoder;const addr : Pointer);
var
  _why: TNamingContext_NotFoundReason;
  _rest_of_name: TName;
begin
  enc.except_begin('IDL:omg.org/CosNaming/NamingContext/NotFound:1.0');
  _why:= INamingContext_NotFound(addr^).why;
  NamingContext_NotFoundReason_marshaller.marshal(enc,@_why);
  _rest_of_name:= INamingContext_NotFound(addr^).rest_of_name;
  NameComponent_seq_marshaller.marshal(enc,@_rest_of_name);
  enc.except_end;
end;

procedure TNamingContext_NotFound_marshaller._free(var addr: Pointer);
begin
  INamingContext_NotFound(addr^) := nil;
end;

procedure TNamingContext_NotFound_marshaller._create(var addr: Pointer);
begin
  INamingContext_NotFound(addr^) := TNamingContext_NotFound.Create();
end;

procedure TNamingContext_NotFound_marshaller._assign(dst, src: Pointer);
begin
  INamingContext_NotFound(dst^) := INamingContext_NotFound(src^);
end;

{$ENDIF}

//***********************************************************
// TNamingContext_NotFound
//***********************************************************
constructor TNamingContext_NotFound.Create(ex: TNamingContext_NotFound);
begin
  Fwhy:= ex.why;
  Frest_of_name:= ex.rest_of_name;
end;

procedure TNamingContext_NotFound.throw;
begin
  raise TNamingContext_NotFound.Create(self);
end;

function TNamingContext_NotFound.clone(): IORBException;
begin
  result := TNamingContext_NotFound.Create(self);
end;

procedure TNamingContext_NotFound.encode(const enc: IEncoder);
var
  int : INamingContext_NotFound;
begin
  int := self;
  NamingContext_NotFound_marshaller.marshal(enc,@int);
end;

constructor TNamingContext_NotFound.Create(_why: TNamingContext_NotFoundReason;_rest_of_name: TName);
begin
  Fwhy := _why;
  Frest_of_name := _rest_of_name;
end;

function TNamingContext_NotFound.repoid(): PChar;
begin
  result := 'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0';
end;

procedure TNamingContext_NotFound.why(const val: TNamingContext_NotFoundReason);
begin
  Fwhy := val;
end;

function TNamingContext_NotFound.why: TNamingContext_NotFoundReason;
begin
  result := Fwhy;
end;

procedure TNamingContext_NotFound.rest_of_name(const val: TName);
begin
  Frest_of_name := val;
end;

function TNamingContext_NotFound.rest_of_name: TName;
begin
  result := Frest_of_name;
end;

{$IFNDEF USELIB}

//***********************************************************
// TNamingContext_CannotProceed_marshaller
//***********************************************************
function TNamingContext_CannotProceed_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  repoid: string;
  _cxt: INamingContext;
  _rest_of_name: TName;
begin
  result := false;
  if not dec.except_begin(repoid) then exit;
  if not NamingContext_marshaller.demarshal(dec,@_cxt) then exit;
  INamingContext_CannotProceed(addr^).cxt(_cxt);
  if not NameComponent_seq_marshaller.demarshal(dec,@_rest_of_name) then exit;
  INamingContext_CannotProceed(addr^).rest_of_name(_rest_of_name);
  if not dec.except_end then exit;
  result := true;
end;

procedure TNamingContext_CannotProceed_marshaller.marshal(enc: IEncoder;const addr : Pointer);
var
  _cxt: INamingContext;
  _rest_of_name: TName;
begin
  enc.except_begin('IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0');
  _cxt:= INamingContext_CannotProceed(addr^).cxt;
  NamingContext_marshaller.marshal(enc,@_cxt);
  _rest_of_name:= INamingContext_CannotProceed(addr^).rest_of_name;
  NameComponent_seq_marshaller.marshal(enc,@_rest_of_name);
  enc.except_end;
end;

procedure TNamingContext_CannotProceed_marshaller._free(var addr: Pointer);
begin
  INamingContext_CannotProceed(addr^) := nil;
end;

procedure TNamingContext_CannotProceed_marshaller._create(var addr: Pointer);
begin
  INamingContext_CannotProceed(addr^) := TNamingContext_CannotProceed.Create();
end;

procedure TNamingContext_CannotProceed_marshaller._assign(dst, src: Pointer);
begin
  INamingContext_CannotProceed(dst^) := INamingContext_CannotProceed(src^);
end;

{$ENDIF}

//***********************************************************
// TNamingContext_CannotProceed
//***********************************************************
constructor TNamingContext_CannotProceed.Create(ex: TNamingContext_CannotProceed);
begin
  Fcxt:= ex.cxt;
  Frest_of_name:= ex.rest_of_name;
end;

procedure TNamingContext_CannotProceed.throw;
begin
  raise TNamingContext_CannotProceed.Create(self);
end;

function TNamingContext_CannotProceed.clone(): IORBException;
begin
  result := TNamingContext_CannotProceed.Create(self);
end;

procedure TNamingContext_CannotProceed.encode(const enc: IEncoder);
var
  int : INamingContext_CannotProceed;
begin
  int := self;
  NamingContext_CannotProceed_marshaller.marshal(enc,@int);
end;

constructor TNamingContext_CannotProceed.Create(_cxt: INamingContext;_rest_of_name: TName);
begin
  Fcxt := _cxt;
  Frest_of_name := _rest_of_name;
end;

function TNamingContext_CannotProceed.repoid(): PChar;
begin
  result := 'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0';
end;

procedure TNamingContext_CannotProceed.cxt(const val: INamingContext);
begin
  Fcxt := val;
end;

function TNamingContext_CannotProceed.cxt: INamingContext;
begin
  result := Fcxt;
end;

procedure TNamingContext_CannotProceed.rest_of_name(const val: TName);
begin
  Frest_of_name := val;
end;

function TNamingContext_CannotProceed.rest_of_name: TName;
begin
  result := Frest_of_name;
end;

{$IFNDEF USELIB}

//***********************************************************
// TNamingContext_InvalidName_marshaller
//***********************************************************
function TNamingContext_InvalidName_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  repoid: string;
begin
  result := false;
  if not dec.except_begin(repoid) then exit;
  if not dec.except_end then exit;
  result := true;
end;

procedure TNamingContext_InvalidName_marshaller.marshal(enc: IEncoder;const addr : Pointer);
begin
  enc.except_begin('IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0');
  enc.except_end;
end;

procedure TNamingContext_InvalidName_marshaller._free(var addr: Pointer);
begin
  INamingContext_InvalidName(addr^) := nil;
end;

procedure TNamingContext_InvalidName_marshaller._create(var addr: Pointer);
begin
  INamingContext_InvalidName(addr^) := TNamingContext_InvalidName.Create();
end;

procedure TNamingContext_InvalidName_marshaller._assign(dst, src: Pointer);
begin
  INamingContext_InvalidName(dst^) := INamingContext_InvalidName(src^);
end;

{$ENDIF}

//***********************************************************
// TNamingContext_InvalidName
//***********************************************************
constructor TNamingContext_InvalidName.Create(ex: TNamingContext_InvalidName);
begin
end;

procedure TNamingContext_InvalidName.throw;
begin
  raise TNamingContext_InvalidName.Create(self);
end;

function TNamingContext_InvalidName.clone(): IORBException;
begin
  result := TNamingContext_InvalidName.Create(self);
end;

procedure TNamingContext_InvalidName.encode(const enc: IEncoder);
var
  int : INamingContext_InvalidName;
begin
  int := self;
  NamingContext_InvalidName_marshaller.marshal(enc,@int);
end;

constructor TNamingContext_InvalidName.Create();
begin
end;

function TNamingContext_InvalidName.repoid(): PChar;
begin
  result := 'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0';
end;

{$IFNDEF USELIB}

//***********************************************************
// TNamingContext_AlreadyBound_marshaller
//***********************************************************
function TNamingContext_AlreadyBound_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  repoid: string;
begin
  result := false;
  if not dec.except_begin(repoid) then exit;
  if not dec.except_end then exit;
  result := true;
end;

procedure TNamingContext_AlreadyBound_marshaller.marshal(enc: IEncoder;const addr : Pointer);
begin
  enc.except_begin('IDL:omg.org/CosNaming/NamingContext/AlreadyBound:1.0');
  enc.except_end;
end;

procedure TNamingContext_AlreadyBound_marshaller._free(var addr: Pointer);
begin
  INamingContext_AlreadyBound(addr^) := nil;
end;

procedure TNamingContext_AlreadyBound_marshaller._create(var addr: Pointer);
begin
  INamingContext_AlreadyBound(addr^) := TNamingContext_AlreadyBound.Create();
end;

procedure TNamingContext_AlreadyBound_marshaller._assign(dst, src: Pointer);
begin
  INamingContext_AlreadyBound(dst^) := INamingContext_AlreadyBound(src^);
end;

{$ENDIF}

//***********************************************************
// TNamingContext_AlreadyBound
//***********************************************************
constructor TNamingContext_AlreadyBound.Create(ex: TNamingContext_AlreadyBound);
begin
end;

procedure TNamingContext_AlreadyBound.throw;
begin
  raise TNamingContext_AlreadyBound.Create(self);
end;

function TNamingContext_AlreadyBound.clone(): IORBException;
begin
  result := TNamingContext_AlreadyBound.Create(self);
end;

procedure TNamingContext_AlreadyBound.encode(const enc: IEncoder);
var
  int : INamingContext_AlreadyBound;
begin
  int := self;
  NamingContext_AlreadyBound_marshaller.marshal(enc,@int);
end;

constructor TNamingContext_AlreadyBound.Create();
begin
end;

function TNamingContext_AlreadyBound.repoid(): PChar;
begin
  result := 'IDL:omg.org/CosNaming/NamingContext/AlreadyBound:1.0';
end;

{$IFNDEF USELIB}

//***********************************************************
// TNamingContext_NotEmpty_marshaller
//***********************************************************
function TNamingContext_NotEmpty_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  repoid: string;
begin
  result := false;
  if not dec.except_begin(repoid) then exit;
  if not dec.except_end then exit;
  result := true;
end;

procedure TNamingContext_NotEmpty_marshaller.marshal(enc: IEncoder;const addr : Pointer);
begin
  enc.except_begin('IDL:omg.org/CosNaming/NamingContext/NotEmpty:1.0');
  enc.except_end;
end;

procedure TNamingContext_NotEmpty_marshaller._free(var addr: Pointer);
begin
  INamingContext_NotEmpty(addr^) := nil;
end;

procedure TNamingContext_NotEmpty_marshaller._create(var addr: Pointer);
begin
  INamingContext_NotEmpty(addr^) := TNamingContext_NotEmpty.Create();
end;

procedure TNamingContext_NotEmpty_marshaller._assign(dst, src: Pointer);
begin
  INamingContext_NotEmpty(dst^) := INamingContext_NotEmpty(src^);
end;

{$ENDIF}

//***********************************************************
// TNamingContext_NotEmpty
//***********************************************************
constructor TNamingContext_NotEmpty.Create(ex: TNamingContext_NotEmpty);
begin
end;

procedure TNamingContext_NotEmpty.throw;
begin
  raise TNamingContext_NotEmpty.Create(self);
end;

function TNamingContext_NotEmpty.clone(): IORBException;
begin
  result := TNamingContext_NotEmpty.Create(self);
end;

procedure TNamingContext_NotEmpty.encode(const enc: IEncoder);
var
  int : INamingContext_NotEmpty;
begin
  int := self;
  NamingContext_NotEmpty_marshaller.marshal(enc,@int);
end;

constructor TNamingContext_NotEmpty.Create();
begin
end;

function TNamingContext_NotEmpty.repoid(): PChar;
begin
  result := 'IDL:omg.org/CosNaming/NamingContext/NotEmpty:1.0';
end;

{$IFNDEF USELIB}

//***********************************************************
// TNamingContext
//***********************************************************
function TNamingContext.narrow_helper(const str: string): Pointer;
begin
  result := nil;
  if str = 'IDL:omg.org/CosNaming/NamingContext:1.0' then
    begin
      result := Pointer(self as INamingContext);
      exit;
    end;
end;

class function TNamingContext._narrow(const obj : IORBObject): INamingContext;
var
  p: Pointer;
  stub: TNamingContext_stub;
begin
  result := nil;
  if obj = nil then exit;
  p := obj.narrow_helper('IDL:omg.org/CosNaming/NamingContext:1.0');
  if p <> nil then
    result := INamingContext(p)
  else
    begin
      if narrow_helper2(obj) or obj._is_a_remote('IDL:omg.org/CosNaming/NamingContext:1.0') then
        begin
          stub := TNamingContext_stub.Create();
          stub.assign(obj);
          result := stub;
        end;
    end;
end;

class function TNamingContext.narrow_helper2(const obj: IORBObject): Boolean;
begin
  result := obj.repoid = 'IDL:omg.org/CosNaming/NamingContext:1.0'
end;

procedure TNamingContext._destroy;
begin
  assert(false,'must be implemented in descendant Classes');
end;

procedure TNamingContext.bind(const n: TName; const obj: IORBObject);
begin
  assert(false,'must be implemented in descendant Classes');
end;

procedure TNamingContext.bind_context(const n: TName;
  const nc: INamingContext);
begin
  assert(false,'must be implemented in descendant Classes');
end;

function TNamingContext.bind_new_context(const n: TName): INamingContext;
begin
  result := nil;
  assert(false,'must be implemented in descendant Classes');
end;

procedure TNamingContext.list(const how_many: _ulong; out bl: TBindingList;
  out bi: IBindingIterator);
begin
  assert(false,'must be implemented in descendant Classes');
end;

function TNamingContext.new_context: INamingContext;
begin
  result := nil;
  assert(false,'must be implemented in descendant Classes');
end;

procedure TNamingContext.rebind(const n: TName; const obj: IORBObject);
begin
  assert(false,'must be implemented in descendant Classes');
end;

procedure TNamingContext.rebind_context(const n: TName;
  const nc: INamingContext);
begin
  assert(false,'must be implemented in descendant Classes');
end;

function TNamingContext.resolve(const n: TName): IORBObject;
begin
  result := nil;
  assert(false,'must be implemented in descendant Classes');
end;

procedure TNamingContext.unbind(const n: TName);
begin
  assert(false,'must be implemented in descendant Classes');
end;

//***********************************************************
// TNamingContext_stub
//***********************************************************
procedure TNamingContext_stub.bind(const n: TName; const obj: IORBObject);
var
  req: IStaticRequest;
  _n: IStaticAny;
  _obj: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _obj := StaticAny(stat_object,@obj);
  req := StaticRequest(self,'bind');
  req.add_in_arg(_n);
  req.add_in_arg(_obj);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0', NamingContext_AlreadyBound_marshaller,'IDL:omg.org/CosNaming/NamingContext/AlreadyBound:1.0']);
end;

procedure TNamingContext_stub.rebind(const n: TName; const obj: IORBObject);
var
  req: IStaticRequest;
  _n: IStaticAny;
  _obj: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _obj := StaticAny(stat_object,@obj);
  req := StaticRequest(self,'rebind');
  req.add_in_arg(_n);
  req.add_in_arg(_obj);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
end;

procedure TNamingContext_stub.bind_context(const n: TName; const nc: INamingContext);
var
  req: IStaticRequest;
  _n: IStaticAny;
  _nc: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _nc := StaticAny(NamingContext_marshaller,@nc);
  req := StaticRequest(self,'bind_context');
  req.add_in_arg(_n);
  req.add_in_arg(_nc);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0', NamingContext_AlreadyBound_marshaller,'IDL:omg.org/CosNaming/NamingContext/AlreadyBound:1.0']);
end;

procedure TNamingContext_stub.rebind_context(const n: TName; const nc: INamingContext);
var
  req: IStaticRequest;
  _n: IStaticAny;
  _nc: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _nc := StaticAny(NamingContext_marshaller,@nc);
  req := StaticRequest(self,'rebind_context');
  req.add_in_arg(_n);
  req.add_in_arg(_nc);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
end;

function TNamingContext_stub.resolve(const n: TName): IORBObject;
var
  req: IStaticRequest;
  _n: IStaticAny;
  _result: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _result := StaticAny(stat_object);
  req := StaticRequest(self,'resolve');
  req.add_in_arg(_n);
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
  result := IORBObject(_result.value^);
end;

procedure TNamingContext_stub.unbind(const n: TName);
var
  req: IStaticRequest;
  _n: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  req := StaticRequest(self,'unbind');
  req.add_in_arg(_n);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
end;

function TNamingContext_stub.new_context: INamingContext;
var
  req: IStaticRequest;
  _result: IStaticAny;
begin
  _result := StaticAny(NamingContext_marshaller);
  req := StaticRequest(self,'new_context');
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req);
  result := INamingContext(_result.value^);
end;

function TNamingContext_stub.bind_new_context(const n: TName): INamingContext;
var
  req: IStaticRequest;
  _n: IStaticAny;
  _result: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _result := StaticAny(NamingContext_marshaller);
  req := StaticRequest(self,'bind_new_context');
  req.add_in_arg(_n);
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_AlreadyBound_marshaller,'IDL:omg.org/CosNaming/NamingContext/AlreadyBound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
  result := INamingContext(_result.value^);
end;

procedure TNamingContext_stub._destroy;
var
  req: IStaticRequest;
begin
  req := StaticRequest(self,'destroy');
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotEmpty_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotEmpty:1.0']);
end;

procedure TNamingContext_stub.list(const how_many: _ulong; out bl: TBindingList; out bi: IBindingIterator);
var
  req: IStaticRequest;
  _how_many: IStaticAny;
  _bl: IStaticAny;
  _bi: IStaticAny;
begin
  _how_many := StaticAny(stat_ulong,@how_many);
  _bl := StaticAny(Binding_seq_marshaller,@bl);
  _bi := StaticAny(BindingIterator_marshaller,@bi);
  req := StaticRequest(self,'list');
  req.add_in_arg(_how_many);
  req.add_out_arg(_bl);
  req.add_out_arg(_bi);
  req.invoke;
  dorb_static_throw(req);
end;

//***********************************************************
// TNamingContext_stub_clp
//***********************************************************
function TNamingContext_stub_clp.narrow_helper(const str: string): Pointer;
begin
  result := nil;
  if str = 'IDL:omg.org/CosNaming/NamingContext:1.0' then
    begin
      result := Pointer(self as INamingContext);
      exit;
    end;
end;

procedure TNamingContext_stub_clp.bind(const n: TName; const obj: IORBObject);
var
  _srv: IServant;
  srv: INamingContext;
begin
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContext_serv._narrow(_srv);
      if srv <> nil then
        srv.bind(n, obj)
    end;
  _postinvoke();
end;

procedure TNamingContext_stub_clp.rebind(const n: TName; const obj: IORBObject);
var
  _srv: IServant;
  srv: INamingContext;
begin
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContext_serv._narrow(_srv);
      if srv <> nil then
        srv.rebind(n, obj)
    end;
  _postinvoke();
end;

procedure TNamingContext_stub_clp.bind_context(const n: TName; const nc: INamingContext);
var
  _srv: IServant;
  srv: INamingContext;
begin
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContext_serv._narrow(_srv);
      if srv <> nil then
        srv.bind_context(n, nc)
    end;
  _postinvoke();
end;

procedure TNamingContext_stub_clp.rebind_context(const n: TName; const nc: INamingContext);
var
  _srv: IServant;
  srv: INamingContext;
begin
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContext_serv._narrow(_srv);
      if srv <> nil then
        srv.rebind_context(n, nc)
    end;
  _postinvoke();
end;

function TNamingContext_stub_clp.resolve(const n: TName): IORBObject;
var
  _srv: IServant;
  srv: INamingContext;
begin
  result := nil;
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContext_serv._narrow(_srv);
      if srv <> nil then
        result := srv.resolve(n)
    end;
  _postinvoke();
end;

procedure TNamingContext_stub_clp.unbind(const n: TName);
var
  _srv: IServant;
  srv: INamingContext;
begin
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContext_serv._narrow(_srv);
      if srv <> nil then
        srv.unbind(n)
    end;
  _postinvoke();
end;

function TNamingContext_stub_clp.new_context: INamingContext;
var
  _srv: IServant;
  srv: INamingContext;
begin
  result := nil;
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContext_serv._narrow(_srv);
      if srv <> nil then
        result := srv.new_context
    end;
  _postinvoke();
end;

function TNamingContext_stub_clp.bind_new_context(const n: TName): INamingContext;
var
  _srv: IServant;
  srv: INamingContext;
begin
  result := nil;
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContext_serv._narrow(_srv);
      if srv <> nil then
        result := srv.bind_new_context(n)
    end;
  _postinvoke();
end;

procedure TNamingContext_stub_clp._destroy;
var
  _srv: IServant;
  srv: INamingContext;
begin
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContext_serv._narrow(_srv);
      if srv <> nil then
        srv._destroy
    end;
  _postinvoke();
end;

procedure TNamingContext_stub_clp.list(const how_many: _ulong; out bl: TBindingList; out bi: IBindingIterator);
var
  _srv: IServant;
  srv: INamingContext;
begin
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContext_serv._narrow(_srv);
      if srv <> nil then
        srv.list(how_many, bl, bi)
    end;
  _postinvoke();
end;

{$ENDIF}

//***********************************************************
// TNamingContext_serv
//***********************************************************
function TNamingContext_serv._this(): INamingContext;
var
  obj: IORBObject;
begin
  obj := this();
  result := NamingContext_narrow(obj);
end;

function TNamingContext_serv._is_a(const repoid: string): Boolean;
begin
  result := repoid = 'IDL:omg.org/CosNaming/NamingContext:1.0';
end;

function TNamingContext_serv._primary_interface(const objid: ObjectID; const poa: IPOA): string;
begin
  result := 'IDL:omg.org/CosNaming/NamingContext:1.0';
end;

function TNamingContext_serv._make_stub(const poa: IPOA; const obj : IORBObject): IORBObject;
begin
  result := NamingContext_stub_clp(poa,obj);
end;

procedure TNamingContext_serv.invoke(const serv: IStaticServerRequest);
begin
  if not _dispatch(serv) then
    begin
      serv.set_exception(SystemException.Create_type(st_BAD_OPERATION,0,COMPLETED_NO) as IORBException);
      serv.write_results();
    end;
end;

function TNamingContext_serv.narrow_helper(const str: string): Pointer;
begin
  result := nil;
  if str = 'IDL:omg.org/CosNaming/NamingContext:1.0' then
    begin
      result := Pointer(INamingContext(self));
      exit;
    end;
end;

class function TNamingContext_serv._narrow(const srv : IServant): INamingContext;
var
  p: Pointer;
begin
  result := nil;
  if srv = nil then exit;
  p := srv.narrow_helper('IDL:omg.org/CosNaming/NamingContext:1.0');
  if p <> nil then
    result := INamingContext(p)
end;

function TNamingContext_serv._dispatch(const req: IStaticServerRequest): Boolean;
var
  bind_n: TName;
  bind_obj: IORBObject;
  rebind_n: TName;
  rebind_obj: IORBObject;
  bind_context_n: TName;
  bind_context_nc: INamingContext;
  rebind_context_n: TName;
  rebind_context_nc: INamingContext;
  resolve_result: IORBObject;
  resolve_n: TName;
  unbind_n: TName;
  new_context_result: INamingContext;
  bind_new_context_result: INamingContext;
  bind_new_context_n: TName;
  list_how_many: _ulong;
  list_bl: TBindingList;
  list_bi: IBindingIterator;
begin
  result := true;
  if req.op_name = 'bind' then
    begin
      req.add_in_arg(StaticAny(NameComponent_seq_marshaller,@bind_n));
      req.add_in_arg(StaticAny(stat_object,@bind_obj));
      if not req.read_args() then  exit;
      try
        bind(bind_n, bind_obj);
      except
        on NotFound: TNamingContext_NotFound do
          req.set_exception(TNamingContext_NotFound.Create(NotFound) as IORBException);
        on CannotProceed: TNamingContext_CannotProceed do
          req.set_exception(TNamingContext_CannotProceed.Create(CannotProceed) as IORBException);
        on InvalidName: TNamingContext_InvalidName do
          req.set_exception(TNamingContext_InvalidName.Create(InvalidName) as IORBException);
        on AlreadyBound: TNamingContext_AlreadyBound do
          req.set_exception(TNamingContext_AlreadyBound.Create(AlreadyBound) as IORBException);
      end;
      req.write_results();
      exit;
    end
  else if req.op_name = 'rebind' then
    begin
      req.add_in_arg(StaticAny(NameComponent_seq_marshaller,@rebind_n));
      req.add_in_arg(StaticAny(stat_object,@rebind_obj));
      if not req.read_args() then  exit;
      try
        rebind(rebind_n, rebind_obj);
      except
        on NotFound: TNamingContext_NotFound do
          req.set_exception(TNamingContext_NotFound.Create(NotFound) as IORBException);
        on CannotProceed: TNamingContext_CannotProceed do
          req.set_exception(TNamingContext_CannotProceed.Create(CannotProceed) as IORBException);
        on InvalidName: TNamingContext_InvalidName do
          req.set_exception(TNamingContext_InvalidName.Create(InvalidName) as IORBException);
      end;
      req.write_results();
      exit;
    end
  else if req.op_name = 'bind_context' then
    begin
      req.add_in_arg(StaticAny(NameComponent_seq_marshaller,@bind_context_n));
      req.add_in_arg(StaticAny(NamingContext_marshaller,@bind_context_nc));
      if not req.read_args() then  exit;
      try
        bind_context(bind_context_n, bind_context_nc);
      except
        on NotFound: TNamingContext_NotFound do
          req.set_exception(TNamingContext_NotFound.Create(NotFound) as IORBException);
        on CannotProceed: TNamingContext_CannotProceed do
          req.set_exception(TNamingContext_CannotProceed.Create(CannotProceed) as IORBException);
        on InvalidName: TNamingContext_InvalidName do
          req.set_exception(TNamingContext_InvalidName.Create(InvalidName) as IORBException);
        on AlreadyBound: TNamingContext_AlreadyBound do
          req.set_exception(TNamingContext_AlreadyBound.Create(AlreadyBound) as IORBException);
      end;
      req.write_results();
      exit;
    end
  else if req.op_name = 'rebind_context' then
    begin
      req.add_in_arg(StaticAny(NameComponent_seq_marshaller,@rebind_context_n));
      req.add_in_arg(StaticAny(NamingContext_marshaller,@rebind_context_nc));
      if not req.read_args() then  exit;
      try
        rebind_context(rebind_context_n, rebind_context_nc);
      except
        on NotFound: TNamingContext_NotFound do
          req.set_exception(TNamingContext_NotFound.Create(NotFound) as IORBException);
        on CannotProceed: TNamingContext_CannotProceed do
          req.set_exception(TNamingContext_CannotProceed.Create(CannotProceed) as IORBException);
        on InvalidName: TNamingContext_InvalidName do
          req.set_exception(TNamingContext_InvalidName.Create(InvalidName) as IORBException);
      end;
      req.write_results();
      exit;
    end
  else if req.op_name = 'resolve' then
    begin
      req.add_in_arg(StaticAny(NameComponent_seq_marshaller,@resolve_n));
      req.set_result(StaticAny(stat_object,@resolve_result));
      if not req.read_args() then  exit;
      try
        resolve_result := resolve(resolve_n);
      except
        on NotFound: TNamingContext_NotFound do
          req.set_exception(TNamingContext_NotFound.Create(NotFound) as IORBException);
        on CannotProceed: TNamingContext_CannotProceed do
          req.set_exception(TNamingContext_CannotProceed.Create(CannotProceed) as IORBException);
        on InvalidName: TNamingContext_InvalidName do
          req.set_exception(TNamingContext_InvalidName.Create(InvalidName) as IORBException);
      end;
      req.write_results();
      exit;
    end
  else if req.op_name = 'unbind' then
    begin
      req.add_in_arg(StaticAny(NameComponent_seq_marshaller,@unbind_n));
      if not req.read_args() then  exit;
      try
        unbind(unbind_n);
      except
        on NotFound: TNamingContext_NotFound do
          req.set_exception(TNamingContext_NotFound.Create(NotFound) as IORBException);
        on CannotProceed: TNamingContext_CannotProceed do
          req.set_exception(TNamingContext_CannotProceed.Create(CannotProceed) as IORBException);
        on InvalidName: TNamingContext_InvalidName do
          req.set_exception(TNamingContext_InvalidName.Create(InvalidName) as IORBException);
      end;
      req.write_results();
      exit;
    end
  else if req.op_name = 'new_context' then
    begin
      req.set_result(StaticAny(NamingContext_marshaller,@new_context_result));
      if not req.read_args() then  exit;
      new_context_result := new_context;
      req.write_results();
      exit;
    end
  else if req.op_name = 'bind_new_context' then
    begin
      req.add_in_arg(StaticAny(NameComponent_seq_marshaller,@bind_new_context_n));
      req.set_result(StaticAny(NamingContext_marshaller,@bind_new_context_result));
      if not req.read_args() then  exit;
      try
        bind_new_context_result := bind_new_context(bind_new_context_n);
      except
        on NotFound: TNamingContext_NotFound do
          req.set_exception(TNamingContext_NotFound.Create(NotFound) as IORBException);
        on AlreadyBound: TNamingContext_AlreadyBound do
          req.set_exception(TNamingContext_AlreadyBound.Create(AlreadyBound) as IORBException);
        on CannotProceed: TNamingContext_CannotProceed do
          req.set_exception(TNamingContext_CannotProceed.Create(CannotProceed) as IORBException);
        on InvalidName: TNamingContext_InvalidName do
          req.set_exception(TNamingContext_InvalidName.Create(InvalidName) as IORBException);
      end;
      req.write_results();
      exit;
    end
  else if req.op_name = 'destroy' then
    begin
      if not req.read_args() then  exit;
      try
        _destroy;
      except
        on NotEmpty: TNamingContext_NotEmpty do
          req.set_exception(TNamingContext_NotEmpty.Create(NotEmpty) as IORBException);
      end;
      req.write_results();
      exit;
    end
  else if req.op_name = 'list' then
    begin
      req.add_in_arg(StaticAny(stat_ulong,@list_how_many));
      req.add_out_arg(StaticAny(Binding_seq_marshaller,@list_bl));
      req.add_out_arg(StaticAny(BindingIterator_marshaller,@list_bi));
      if not req.read_args() then  exit;
      list(list_how_many, list_bl, list_bi);
      req.write_results();
      exit;
    end;
  result := false;
end;

{$IFNDEF USELIB}

//***********************************************************
// TNamingContext_marshaller
//***********************************************************
function TNamingContext_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  obj: IORBObject;
begin
  result := false;
  if not stat_Object.demarshal(dec,@obj) then exit;
  INamingContext(addr^) := TNamingContext._narrow(obj);
  result := (obj = nil) or (Pointer(addr^) <> nil);
end;

procedure TNamingContext_marshaller.marshal(enc: IEncoder;const addr : Pointer);
var
  obj: IORBObject;
begin
  obj := INamingContext(addr^) as IORBObject;
  stat_Object.marshal(enc,@Pointer(obj));
end;

procedure TNamingContext_marshaller._free(var addr: Pointer);
begin
  INamingContext(addr^) := nil;
end;

procedure TNamingContext_marshaller._create(var addr: Pointer);
begin
  INamingContext(addr^) := TNamingContext.Create();
end;

procedure TNamingContext_marshaller._assign(dst, src: Pointer);
begin
  INamingContext(dst^) := INamingContext(src^);
end;

{$ENDIF}

//***********************************************************
// TBindingIterator
//***********************************************************
function TBindingIterator.narrow_helper(const str: string): Pointer;
begin
  result := nil;
  if str = 'IDL:omg.org/CosNaming/BindingIterator:1.0' then
    begin
      result := Pointer(self as IBindingIterator);
      exit;
    end;
end;

class function TBindingIterator._narrow(const obj : IORBObject): IBindingIterator;
var
  p: Pointer;
  stub: TBindingIterator_stub;
begin
  result := nil;
  if obj = nil then exit;
  p := obj.narrow_helper('IDL:omg.org/CosNaming/BindingIterator:1.0');
  if p <> nil then
    result := IBindingIterator(p)
  else
    begin
      if narrow_helper2(obj) or obj._is_a_remote('IDL:omg.org/CosNaming/BindingIterator:1.0') then
        begin
          stub := TBindingIterator_stub.Create();
          stub.assign(obj);
          result := stub;
        end;
    end;
end;

class function TBindingIterator.narrow_helper2(const obj: IORBObject): Boolean;
begin
  result := obj.repoid = 'IDL:omg.org/CosNaming/BindingIterator:1.0'
end;

procedure TBindingIterator._destroy;
begin
  assert(false,'must be implemented in descendant Classes');
end;

function TBindingIterator.next_n(const how_many: _ulong;
  out bl: TBindingList): boolean;
begin
  result := false;
  assert(false,'must be implemented in descendant Classes');
end;

function TBindingIterator.next_one(out b: TBinding): boolean;
begin
  result := false;
  assert(false,'must be implemented in descendant Classes');
end;

//***********************************************************
// TBindingIterator_stub
//***********************************************************
function TBindingIterator_stub.next_one(out b: TBinding): boolean;
var
  req: IStaticRequest;
  _b: IStaticAny;
  _result: IStaticAny;
begin
  _b := StaticAny(Binding_marshaller,@b);
  _result := StaticAny(stat_boolean);
  req := StaticRequest(self,'next_one');
  req.add_out_arg(_b);
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req);
  result := boolean(_result.value^);
end;

function TBindingIterator_stub.next_n(const how_many: _ulong; out bl: TBindingList): boolean;
var
  req: IStaticRequest;
  _how_many: IStaticAny;
  _bl: IStaticAny;
  _result: IStaticAny;
begin
  _how_many := StaticAny(stat_ulong,@how_many);
  _bl := StaticAny(Binding_seq_marshaller,@bl);
  _result := StaticAny(stat_boolean);
  req := StaticRequest(self,'next_n');
  req.add_in_arg(_how_many);
  req.add_out_arg(_bl);
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req);
  result := boolean(_result.value^);
end;

procedure TBindingIterator_stub._destroy;
var
  req: IStaticRequest;
begin
  req := StaticRequest(self,'destroy');
  req.invoke;
  dorb_static_throw(req);
end;

//***********************************************************
// TBindingIterator_stub_clp
//***********************************************************
function TBindingIterator_stub_clp.narrow_helper(const str: string): Pointer;
begin
  result := nil;
  if str = 'IDL:omg.org/CosNaming/BindingIterator:1.0' then
    begin
      result := Pointer(self as IBindingIterator);
      exit;
    end;
end;

function TBindingIterator_stub_clp.next_one(out b: TBinding): boolean;
var
  _srv: IServant;
  srv: IBindingIterator;
begin
  result := false;
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TBindingIterator_serv._narrow(_srv);
      if srv <> nil then
        result := srv.next_one(b)
    end;
  _postinvoke();
end;

function TBindingIterator_stub_clp.next_n(const how_many: _ulong; out bl: TBindingList): boolean;
var
  _srv: IServant;
  srv: IBindingIterator;
begin
  result := false;
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TBindingIterator_serv._narrow(_srv);
      if srv <> nil then
        result := srv.next_n(how_many, bl)
    end;
  _postinvoke();
end;

procedure TBindingIterator_stub_clp._destroy;
var
  _srv: IServant;
  srv: IBindingIterator;
begin
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TBindingIterator_serv._narrow(_srv);
      if srv <> nil then
        srv._destroy
    end;
  _postinvoke();
end;

//***********************************************************
// TBindingIterator_serv
//***********************************************************
function TBindingIterator_serv._this(): IBindingIterator;
var
  obj: IORBObject;
begin
  obj := this();
  result := TBindingIterator._narrow(obj);
end;

function TBindingIterator_serv._is_a(const repoid: string): Boolean;
begin
  result := repoid = 'IDL:omg.org/CosNaming/BindingIterator:1.0';
end;

function TBindingIterator_serv._primary_interface(const objid: ObjectID; const poa: IPOA): string;
begin
  result := 'IDL:omg.org/CosNaming/BindingIterator:1.0';
end;

function TBindingIterator_serv._make_stub(const poa: IPOA; const obj : IORBObject): IORBObject;
begin
  result := TBindingIterator_stub_clp.Create(poa,obj);
end;

procedure TBindingIterator_serv.invoke(const serv: IStaticServerRequest);
begin
  if not _dispatch(serv) then
    begin
      serv.set_exception(SystemException.Create_type(st_BAD_OPERATION,0,COMPLETED_NO));
      serv.write_results();
    end;
end;

function TBindingIterator_serv.narrow_helper(const str: string): Pointer;
begin
  result := nil;
  if str = 'IDL:omg.org/CosNaming/BindingIterator:1.0' then
    begin
      result := Pointer(IBindingIterator(self));
      exit;
    end;
end;

class function TBindingIterator_serv._narrow(const srv : IServant): IBindingIterator;
var
  p: Pointer;
begin
  result := nil;
  if srv = nil then exit;
  p := srv.narrow_helper('IDL:omg.org/CosNaming/BindingIterator:1.0');
  if p <> nil then
    result := IBindingIterator(p)
end;

function TBindingIterator_serv._dispatch(const req: IStaticServerRequest): Boolean;
var
  next_one_result: boolean;
  next_one_b: TBinding;
  next_n_result: boolean;
  next_n_how_many: _ulong;
  next_n_bl: TBindingList;
begin
  result := true;
  if req.op_name = 'next_one' then
    begin
      req.add_out_arg(StaticAny(Binding_marshaller,@next_one_b));
      req.set_result(StaticAny(stat_boolean,@next_one_result));
      if not req.read_args() then  exit;
      next_one_result := next_one(next_one_b);
      req.write_results();
      exit;
    end
  else if req.op_name = 'next_n' then
    begin
      req.add_in_arg(StaticAny(stat_ulong,@next_n_how_many));
      req.add_out_arg(StaticAny(Binding_seq_marshaller,@next_n_bl));
      req.set_result(StaticAny(stat_boolean,@next_n_result));
      if not req.read_args() then  exit;
      next_n_result := next_n(next_n_how_many, next_n_bl);
      req.write_results();
      exit;
    end
  else if req.op_name = 'destroy' then
    begin
      if not req.read_args() then  exit;
      _destroy;
      req.write_results();
      exit;
    end;
  result := false;
end;

{$IFNDEF USELIB}

//***********************************************************
// TBindingIterator_marshaller
//***********************************************************
function TBindingIterator_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  obj: IORBObject;
begin
  result := false;
  if not stat_Object.demarshal(dec,@obj) then exit;
  IBindingIterator(addr^) := TBindingIterator._narrow(obj);
  result := (obj = nil) or (Pointer(addr^) <> nil);
end;

procedure TBindingIterator_marshaller.marshal(enc: IEncoder;const addr : Pointer);
var
  obj: IORBObject;
begin
  obj := IBindingIterator(addr^) as IORBObject;
  stat_Object.marshal(enc,@Pointer(obj));
end;

procedure TBindingIterator_marshaller._free(var addr: Pointer);
begin
  IBindingIterator(addr^) := nil;
end;

procedure TBindingIterator_marshaller._create(var addr: Pointer);
begin
  IBindingIterator(addr^) := TBindingIterator.Create();
end;

procedure TBindingIterator_marshaller._assign(dst, src: Pointer);
begin
  IBindingIterator(dst^) := IBindingIterator(src^);
end;

//***********************************************************
// TNamingContextExt_InvalidAddress_marshaller
//***********************************************************
function TNamingContextExt_InvalidAddress_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  repoid: string;
begin
  result := false;
  if not dec.except_begin(repoid) then exit;
  if not dec.except_end then exit;
  result := true;
end;

procedure TNamingContextExt_InvalidAddress_marshaller.marshal(enc: IEncoder;const addr : Pointer);
begin
  enc.except_begin('IDL:omg.org/CosNaming/NamingContext/InvalidAddress:1.0');
  enc.except_end;
end;

procedure TNamingContextExt_InvalidAddress_marshaller._free(var addr: Pointer);
begin
  INamingContextExt_InvalidAddress(addr^) := nil;
end;

procedure TNamingContextExt_InvalidAddress_marshaller._create(var addr: Pointer);
begin
  INamingContextExt_InvalidAddress(addr^) := TNamingContextExt_InvalidAddress.Create();
end;

procedure TNamingContextExt_InvalidAddress_marshaller._assign(dst, src: Pointer);
begin
  INamingContextExt_InvalidAddress(dst^) := INamingContextExt_InvalidAddress(src^);
end;

{$ENDIF}

//***********************************************************
// TNamingContextExt_InvalidAddress
//***********************************************************
constructor TNamingContextExt_InvalidAddress.Create(ex: TNamingContextExt_InvalidAddress);
begin
end;

procedure TNamingContextExt_InvalidAddress.throw;
begin
  raise TNamingContextExt_InvalidAddress.Create(self);
end;

function TNamingContextExt_InvalidAddress.clone(): IORBException;
begin
  result := TNamingContextExt_InvalidAddress.Create(self);
end;

procedure TNamingContextExt_InvalidAddress.encode(const enc: IEncoder);
var
  int : INamingContextExt_InvalidAddress;
begin
  int := self;
  NamingContextExt_InvalidAddress_marshaller.marshal(enc,@int);
end;

constructor TNamingContextExt_InvalidAddress.Create();
begin
end;

function TNamingContextExt_InvalidAddress.repoid(): PChar;
begin
  result := 'IDL:omg.org/CosNaming/NamingContext/InvalidAddress:1.0';
end;

{$IFNDEF USELIB}

//***********************************************************
// TNamingContextExt
//***********************************************************
function TNamingContextExt.narrow_helper(const str: string): Pointer;
begin
  if str = 'IDL:omg.org/CosNaming/NamingContextExt:1.0' then
    begin
      result := Pointer(self as INamingContextExt);
      exit;
    end;
  result := inherited narrow_helper(str);
end;

class function TNamingContextExt._narrow(const obj : IORBObject): INamingContextExt;
var
  p: Pointer;
  stub: TNamingContextExt_stub;
begin
  result := nil;
  if obj = nil then exit;
  p := obj.narrow_helper('IDL:omg.org/CosNaming/NamingContextExt:1.0');
  if p <> nil then
    result := INamingContextExt(p)
  else
    begin
      if narrow_helper2(obj) or obj._is_a_remote('IDL:omg.org/CosNaming/NamingContextExt:1.0') then
        begin
          stub := TNamingContextExt_stub.Create();
          stub.assign(obj);
          result := stub;
        end;
    end;
end;

class function TNamingContextExt.narrow_helper2(const obj: IORBObject): Boolean;
begin
  result := obj.repoid = 'IDL:omg.org/CosNaming/NamingContextExt:1.0'
end;

function TNamingContextExt.resolve_str(
  const n: TNamingContextExt_StringName): IORBObject;
begin
  result := nil;
end;

function TNamingContextExt.to_name(
  const sn: TNamingContextExt_StringName): TName;
begin
  result := nil;
end;

function TNamingContextExt.to_string(
  const n: TName): TNamingContextExt_StringName;
begin
  result := '';
end;

function TNamingContextExt.to_url(const addr: TNamingContextExt_Address;
  const sn: TNamingContextExt_StringName): TNamingContextExt_URLString;
begin
  result := '';
end;

//***********************************************************
// TNamingContextExt_stub
//***********************************************************
procedure TNamingContextExt_stub.bind(const n: TName; const obj: IORBObject);
var
  req: IStaticRequest;
  _n: IStaticAny;
  _obj: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _obj := StaticAny(stat_object,@obj);
  req := StaticRequest(self,'bind');
  req.add_in_arg(_n);
  req.add_in_arg(_obj);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0', NamingContext_AlreadyBound_marshaller,'IDL:omg.org/CosNaming/NamingContext/AlreadyBound:1.0']);
end;

procedure TNamingContextExt_stub.rebind(const n: TName; const obj: IORBObject);
var
  req: IStaticRequest;
  _n: IStaticAny;
  _obj: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _obj := StaticAny(stat_object,@obj);
  req := StaticRequest(self,'rebind');
  req.add_in_arg(_n);
  req.add_in_arg(_obj);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
end;

procedure TNamingContextExt_stub.bind_context(const n: TName; const nc: INamingContext);
var
  req: IStaticRequest;
  _n: IStaticAny;
  _nc: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _nc := StaticAny(NamingContext_marshaller,@nc);
  req := StaticRequest(self,'bind_context');
  req.add_in_arg(_n);
  req.add_in_arg(_nc);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0', NamingContext_AlreadyBound_marshaller,'IDL:omg.org/CosNaming/NamingContext/AlreadyBound:1.0']);
end;

procedure TNamingContextExt_stub.rebind_context(const n: TName; const nc: INamingContext);
var
  req: IStaticRequest;
  _n: IStaticAny;
  _nc: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _nc := StaticAny(NamingContext_marshaller,@nc);
  req := StaticRequest(self,'rebind_context');
  req.add_in_arg(_n);
  req.add_in_arg(_nc);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
end;

function TNamingContextExt_stub.resolve(const n: TName): IORBObject;
var
  req: IStaticRequest;
  _n: IStaticAny;
  _result: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _result := StaticAny(stat_object);
  req := StaticRequest(self,'resolve');
  req.add_in_arg(_n);
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
  result := IORBObject(_result.value^);
end;

procedure TNamingContextExt_stub.unbind(const n: TName);
var
  req: IStaticRequest;
  _n: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  req := StaticRequest(self,'unbind');
  req.add_in_arg(_n);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
end;

function TNamingContextExt_stub.new_context: INamingContext;
var
  req: IStaticRequest;
  _result: IStaticAny;
begin
  _result := StaticAny(NamingContext_marshaller);
  req := StaticRequest(self,'new_context');
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req);
  result := INamingContext(_result.value^);
end;

function TNamingContextExt_stub.bind_new_context(const n: TName): INamingContext;
var
  req: IStaticRequest;
  _n: IStaticAny;
  _result: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _result := StaticAny(NamingContext_marshaller);
  req := StaticRequest(self,'bind_new_context');
  req.add_in_arg(_n);
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_AlreadyBound_marshaller,'IDL:omg.org/CosNaming/NamingContext/AlreadyBound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
  result := INamingContext(_result.value^);
end;

procedure TNamingContextExt_stub._destroy;
var
  req: IStaticRequest;
begin
  req := StaticRequest(self,'destroy');
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotEmpty_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotEmpty:1.0']);
end;

procedure TNamingContextExt_stub.list(const how_many: _ulong; out bl: TBindingList; out bi: IBindingIterator);
var
  req: IStaticRequest;
  _how_many: IStaticAny;
  _bl: IStaticAny;
  _bi: IStaticAny;
begin
  _how_many := StaticAny(stat_ulong,@how_many);
  _bl := StaticAny(Binding_seq_marshaller,@bl);
  _bi := StaticAny(BindingIterator_marshaller,@bi);
  req := StaticRequest(self,'list');
  req.add_in_arg(_how_many);
  req.add_out_arg(_bl);
  req.add_out_arg(_bi);
  req.invoke;
  dorb_static_throw(req);
end;

function TNamingContextExt_stub.to_string(const n: TName): TNamingContextExt_StringName;
var
  req: IStaticRequest;
  _n: IStaticAny;
  _result: IStaticAny;
begin
  _n := StaticAny(NameComponent_seq_marshaller,@n);
  _result := StaticAny(stat_string);
  req := StaticRequest(self,'to_string');
  req.add_in_arg(_n);
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req,[NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
  result := TNamingContextExt_StringName(_result.value^);
end;

function TNamingContextExt_stub.to_name(const sn: TNamingContextExt_StringName): TName;
var
  req: IStaticRequest;
  _sn: IStaticAny;
  _result: IStaticAny;
begin
  _sn := StaticAny(stat_string,@sn);
  _result := StaticAny(NameComponent_seq_marshaller);
  req := StaticRequest(self,'to_name');
  req.add_in_arg(_sn);
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req,[NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
  result := TName(_result.value^);
end;

function TNamingContextExt_stub.to_url(const addr: TNamingContextExt_Address; const sn: TNamingContextExt_StringName): TNamingContextExt_URLString;
var
  req: IStaticRequest;
  _addr: IStaticAny;
  _sn: IStaticAny;
  _result: IStaticAny;
begin
  _addr := StaticAny(stat_string,@addr);
  _sn := StaticAny(stat_string,@sn);
  _result := StaticAny(stat_string);
  req := StaticRequest(self,'to_url');
  req.add_in_arg(_addr);
  req.add_in_arg(_sn);
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req,[NamingContextExt_InvalidAddress_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidAddress:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0']);
  result := TNamingContextExt_URLString(_result.value^);
end;

function TNamingContextExt_stub.resolve_str(const n: TNamingContextExt_StringName): IORBObject;
var
  req: IStaticRequest;
  _n: IStaticAny;
  _result: IStaticAny;
begin
  _n := StaticAny(stat_string,@n);
  _result := StaticAny(stat_object);
  req := StaticRequest(self,'resolve_str');
  req.add_in_arg(_n);
  req.set_result(_result);
  req.invoke;
  dorb_static_throw(req,[NamingContext_NotFound_marshaller,'IDL:omg.org/CosNaming/NamingContext/NotFound:1.0', NamingContext_CannotProceed_marshaller,'IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0', NamingContext_InvalidName_marshaller,'IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0', NamingContext_AlreadyBound_marshaller,'IDL:omg.org/CosNaming/NamingContext/AlreadyBound:1.0']);
  result := IORBObject(_result.value^);
end;

//***********************************************************
// TNamingContextExt_stub_clp
//***********************************************************
function TNamingContextExt_stub_clp.narrow_helper(const str: string): Pointer;
begin
  result := nil;
  if str = 'IDL:omg.org/CosNaming/NamingContextExt:1.0' then
    begin
      result := Pointer(self as INamingContextExt);
      exit;
    end;
end;

function TNamingContextExt_stub_clp.to_string(const n: TName): TNamingContextExt_StringName;
var
  _srv: IServant;
  srv: INamingContextExt;
begin
  result := '';
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContextExt_serv._narrow(_srv);
      if srv <> nil then
        result := srv.to_string(n)
    end;
  _postinvoke();
end;

function TNamingContextExt_stub_clp.to_name(const sn: TNamingContextExt_StringName): TName;
var
  _srv: IServant;
  srv: INamingContextExt;
begin
  result := nil;
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContextExt_serv._narrow(_srv);
      if srv <> nil then
        result := srv.to_name(sn)
    end;
  _postinvoke();
end;

function TNamingContextExt_stub_clp.to_url(const addr: TNamingContextExt_Address; const sn: TNamingContextExt_StringName): TNamingContextExt_URLString;
var
  _srv: IServant;
  srv: INamingContextExt;
begin
  result := '';
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContextExt_serv._narrow(_srv);
      if srv <> nil then
        result := srv.to_url(addr, sn)
    end;
  _postinvoke();
end;

function TNamingContextExt_stub_clp.resolve_str(const n: TNamingContextExt_StringName): IORBObject;
var
  _srv: IServant;
  srv: INamingContextExt;
begin
  result := nil;
  _srv := _preinvoke();
  if _srv <> nil then
    begin
      srv := TNamingContextExt_serv._narrow(_srv);
      if srv <> nil then
        result := srv.resolve_str(n)
    end;
  _postinvoke();
end;

{$ENDIF}

//***********************************************************
// TNamingContextExt_serv
//***********************************************************
function TNamingContextExt_serv._this(): INamingContextExt;
var
  obj: IORBObject;
begin
  obj := this();
  result := NamingContextExt_narrow(obj);
end;

function TNamingContextExt_serv._is_a(const repoid: string): Boolean;
begin
  result := (repoid = 'IDL:omg.org/CosNaming/NamingContextExt:1.0') or
    inherited _is_a(repoid);
end;

function TNamingContextExt_serv._primary_interface(const objid: ObjectID; const poa: IPOA): string;
begin
  result := 'IDL:omg.org/CosNaming/NamingContextExt:1.0';
end;

function TNamingContextExt_serv._make_stub(const poa: IPOA; const obj : IORBObject): IORBObject;
begin
  result := NamingContextExt_stub_clp(poa,obj);
end;

procedure TNamingContextExt_serv.invoke(const serv: IStaticServerRequest);
begin
  if not _dispatch(serv) then
    begin
      serv.set_exception(SystemException.Create_type(st_BAD_OPERATION,0,COMPLETED_NO) as IORBException);
      serv.write_results();
    end;
end;

function TNamingContextExt_serv.narrow_helper(const str: string): Pointer;
begin
  if str = 'IDL:omg.org/CosNaming/NamingContextExt:1.0' then
    begin
      result := Pointer(INamingContextExt(self));
      exit;
    end;
  result := inherited narrow_helper(str);
end;

class function TNamingContextExt_serv._narrow(const srv : IServant): INamingContextExt;
var
  p: Pointer;
begin
  result := nil;
  if srv = nil then exit;
  p := srv.narrow_helper('IDL:omg.org/CosNaming/NamingContextExt:1.0');
  if p <> nil then
    result := INamingContextExt(p)
end;

function TNamingContextExt_serv._dispatch(const req: IStaticServerRequest): Boolean;
var
  to_string_result: TNamingContextExt_StringName;
  to_string_n: TName;
  to_name_result: TName;
  to_name_sn: TNamingContextExt_StringName;
  to_url_result: TNamingContextExt_URLString;
  to_url_addr: TNamingContextExt_Address;
  to_url_sn: TNamingContextExt_StringName;
  resolve_str_result: IORBObject;
  resolve_str_n: TNamingContextExt_StringName;
begin
  result := true;
  if req.op_name = 'to_string' then
    begin
      req.add_in_arg(StaticAny(NameComponent_seq_marshaller,@to_string_n) as IStaticAny);
      req.set_result(StaticAny(stat_string,@to_string_result) as IStaticAny);
      if not req.read_args() then  exit;
      try
        to_string_result := to_string(to_string_n);
      except
        on InvalidName: TNamingContext_InvalidName do
          req.set_exception(TNamingContext_InvalidName.Create(InvalidName) as IORBException);
      end;
      req.write_results();
      exit;
    end
  else if req.op_name = 'to_name' then
    begin
      req.add_in_arg(StaticAny(stat_string,@to_name_sn) as IStaticAny);
      req.set_result(StaticAny(NameComponent_seq_marshaller,@to_name_result) as IStaticAny);
      if not req.read_args() then  exit;
      try
        to_name_result := to_name(to_name_sn);
      except
        on InvalidName: TNamingContext_InvalidName do
          req.set_exception(TNamingContext_InvalidName.Create(InvalidName) as IORBException);
      end;
      req.write_results();
      exit;
    end
  else if req.op_name = 'to_url' then
    begin
      req.add_in_arg(StaticAny(stat_string,@to_url_addr) as IStaticAny);
      req.add_in_arg(StaticAny(stat_string,@to_url_sn) as IStaticAny);
      req.set_result(StaticAny(stat_string,@to_url_result) as IStaticAny);
      if not req.read_args() then  exit;
      try
        to_url_result := to_url(to_url_addr, to_url_sn);
      except
        on InvalidAddress: TNamingContextExt_InvalidAddress do
          req.set_exception(TNamingContextExt_InvalidAddress.Create(InvalidAddress) as IORBException);
        on InvalidName: TNamingContext_InvalidName do
          req.set_exception(TNamingContext_InvalidName.Create(InvalidName) as IORBException);
      end;
      req.write_results();
      exit;
    end
  else if req.op_name = 'resolve_str' then
    begin
      req.add_in_arg(StaticAny(stat_string,@resolve_str_n) as IStaticAny);
      req.set_result(StaticAny(stat_object,@resolve_str_result) as IStaticAny);
      if not req.read_args() then  exit;
      try
        resolve_str_result := resolve_str(resolve_str_n);
      except
        on NotFound: TNamingContext_NotFound do
          req.set_exception(TNamingContext_NotFound.Create(NotFound) as IORBException);
        on CannotProceed: TNamingContext_CannotProceed do
          req.set_exception(TNamingContext_CannotProceed.Create(CannotProceed) as IORBException);
        on InvalidName: TNamingContext_InvalidName do
          req.set_exception(TNamingContext_InvalidName.Create(InvalidName) as IORBException);
        on AlreadyBound: TNamingContext_AlreadyBound do
          req.set_exception(TNamingContext_AlreadyBound.Create(AlreadyBound) as IORBException);
      end;
      req.write_results();
      exit;
    end;
  if not inherited _dispatch(req) then
    result := false;
end;

{$IFNDEF USELIB}

//***********************************************************
// TNamingContextExt_marshaller
//***********************************************************
function TNamingContextExt_marshaller.demarshal(dec: IDecoder;const addr : Pointer): Boolean;
var
  obj: IORBObject;
begin
  result := false;
  if not stat_Object.demarshal(dec,@obj) then exit;
  INamingContextExt(addr^) := TNamingContextExt._narrow(obj);
  result := (obj = nil) or (Pointer(addr^) <> nil);
end;

procedure TNamingContextExt_marshaller.marshal(enc: IEncoder;const addr : Pointer);
var
  obj: IORBObject;
begin
  obj := INamingContextExt(addr^) as IORBObject;
  stat_Object.marshal(enc,@Pointer(obj));
end;

procedure TNamingContextExt_marshaller._free(var addr: Pointer);
begin
  INamingContextExt(addr^) := nil;
end;

procedure TNamingContextExt_marshaller._create(var addr: Pointer);
begin
  INamingContextExt(addr^) := TNamingContextExt.Create();
end;

procedure TNamingContextExt_marshaller._assign(dst, src: Pointer);
begin
  INamingContextExt(dst^) := INamingContextExt(src^);
end;


{$ENDIF}

{$IFNDEF USELIB}

{$IFDEF LIBRARY}
function NameComponent_marshaller : IStaticTypeInfo;
begin
  result := _NameComponent_marshaller
end;

function NameComponent_seq_marshaller : IStaticTypeInfo;
begin
  result := _NameComponent_seq_marshaller
end;

function BindingType_marshaller : IStaticTypeInfo;
begin
  result := _BindingType_marshaller
end;

function Binding_marshaller : IStaticTypeInfo;
begin
  result := _Binding_marshaller
end;

function Binding_seq_marshaller : IStaticTypeInfo;
begin
  result := _Binding_seq_marshaller
end;

function NamingContext_NotFoundReason_marshaller : IStaticTypeInfo;
begin
  result := _NamingContext_NotFoundReason_marshaller
end;

function NamingContext_NotFound_marshaller : IStaticTypeInfo;
begin
  result := _NamingContext_NotFound_marshaller
end;

function NamingContext_CannotProceed_marshaller : IStaticTypeInfo;
begin
  result := _NamingContext_CannotProceed_marshaller
end;

function NamingContext_InvalidName_marshaller : IStaticTypeInfo;
begin
  result := _NamingContext_InvalidName_marshaller
end;

function NamingContext_AlreadyBound_marshaller : IStaticTypeInfo;
begin
  result := _NamingContext_AlreadyBound_marshaller
end;

function NamingContext_NotEmpty_marshaller : IStaticTypeInfo;
begin
  result := _NamingContext_NotEmpty_marshaller
end;

function NamingContext_marshaller : IStaticTypeInfo;
begin
  result := _NamingContext_marshaller
end;

function BindingIterator_marshaller : IStaticTypeInfo;
begin
  result := _BindingIterator_marshaller
end;

function NamingContextExt_InvalidAddress_marshaller: IStaticTypeInfo;
begin
  result := NamingContextExt_InvalidAddress_marshaller
end;

function NamingContextExt_marshaller: IStaticTypeInfo;
begin
  result := _NamingContextExt_marshaller;
end;

exports
  NameComponent_marshaller,
  NameComponent_seq_marshaller,
  BindingType_marshaller,
  Binding_marshaller,
  Binding_seq_marshaller,
  NamingContext_NotFoundReason_marshaller,
  NamingContext_NotFound_marshaller,
  NamingContext_CannotProceed_marshaller,
  NamingContext_InvalidName_marshaller,
  NamingContext_AlreadyBound_marshaller,
  NamingContext_NotEmpty_marshaller,
  NamingContext_marshaller,
  NamingContextExt_InvalidAddress_marshaller,
  NamingContextExt_marshaller,
  BindingIterator_marshaller,
  NamingContext_stub_clp,
  NamingContextExt_stub_clp,
  NamingContextExt_narrow,
  NamingContext_narrow;
initialization
  _NameComponent_marshaller := TNameComponent_marshaller.Create();
  _NameComponent_seq_marshaller := TNameComponent_seq_marshaller.Create();
  _BindingType_marshaller := TBindingType_marshaller.Create();
  _Binding_marshaller := TBinding_marshaller.Create();
  _Binding_seq_marshaller := TBinding_seq_marshaller.Create();
  _NamingContext_NotFoundReason_marshaller := TNamingContext_NotFoundReason_marshaller.Create();
  _NamingContext_NotFound_marshaller := TNamingContext_NotFound_marshaller.Create();
  _NamingContext_CannotProceed_marshaller := TNamingContext_CannotProceed_marshaller.Create();
  _NamingContext_InvalidName_marshaller := TNamingContext_InvalidName_marshaller.Create();
  _NamingContext_AlreadyBound_marshaller := TNamingContext_AlreadyBound_marshaller.Create();
  _NamingContext_NotEmpty_marshaller := TNamingContext_NotEmpty_marshaller.Create();
  _NamingContext_marshaller := TNamingContext_marshaller.Create();
  _BindingIterator_marshaller := TBindingIterator_marshaller.Create();
  _NamingContextExt_InvalidAddress_marshaller := TNamingContextExt_InvalidAddress_marshaller.Create();
  _NamingContextExt_marshaller := TNamingContextExt_marshaller.Create();
{$ELSE}
initialization
  NameComponent_marshaller := TNameComponent_marshaller.Create();
  NameComponent_seq_marshaller := TNameComponent_seq_marshaller.Create();
  BindingType_marshaller := TBindingType_marshaller.Create();
  Binding_marshaller := TBinding_marshaller.Create();
  Binding_seq_marshaller := TBinding_seq_marshaller.Create();
  NamingContext_NotFoundReason_marshaller := TNamingContext_NotFoundReason_marshaller.Create();
  NamingContext_NotFound_marshaller := TNamingContext_NotFound_marshaller.Create();
  NamingContext_CannotProceed_marshaller := TNamingContext_CannotProceed_marshaller.Create();
  NamingContext_InvalidName_marshaller := TNamingContext_InvalidName_marshaller.Create();
  NamingContext_AlreadyBound_marshaller := TNamingContext_AlreadyBound_marshaller.Create();
  NamingContext_NotEmpty_marshaller := TNamingContext_NotEmpty_marshaller.Create();
  NamingContext_marshaller := TNamingContext_marshaller.Create();
  BindingIterator_marshaller := TBindingIterator_marshaller.Create();
  NamingContextExt_InvalidAddress_marshaller := TNamingContextExt_InvalidAddress_marshaller.Create();
  NamingContextExt_marshaller := TNamingContextExt_marshaller.Create();
{$ENDIF}
{$ENDIF}
end.
